import { ApolloLink, Operation, FetchResult, Observable as LinkObservable } from 'apollo-link';
import { MonoTypeOperatorFunction } from 'rxjs';
export declare function event<T>(): MonoTypeOperatorFunction<T>;
interface WithOperation {
    operation: Operation;
}
interface OnRequest extends WithOperation {
}
interface OnSuccess extends WithOperation {
    result: FetchResult;
}
interface OnError extends WithOperation {
    error: any;
}
interface OnCancel extends WithOperation {
}
export declare class ApolloNetworkStatus extends ApolloLink {
    private count;
    private pending$;
    private request$;
    private success$;
    private error$;
    private cancel$;
    isPending: import("rxjs").Observable<boolean>;
    onRequest: import("rxjs").Observable<OnRequest>;
    onSuccess: import("rxjs").Observable<OnSuccess>;
    onError: import("rxjs").Observable<OnError>;
    onCancel: import("rxjs").Observable<OnCancel>;
    constructor();
    request(operation: any, forward: any): LinkObservable<{}>;
    _onRequest(data: OnRequest): void;
    _onSuccess(data: OnSuccess): void;
    _onError(data: OnError): void;
    _onCancel(data: OnCancel): void;
    increase(): void;
    decrease(): void;
    update(): void;
}
export declare class ApolloNetworkStatusModule {
}
export {};
